#ifndef _OPENGLCTRL_H_
#define _OPENGLCTRL_H_

#include <CtrlLib/CtrlLib.h>

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glx.h>

class OpenGLCtrl : public Ctrl
{
	GLXContext SubWindowContext;
	Window     SubWindow;
	bool       IsInitialized;
	bool       IsMapped;
	
	Rect RectInTopWindow() const;
	void MapWindow();
	void UnMapWindow();
	bool CreateGLXWindow( Window &, GLXContext & );
	void Paint(Draw& draw);
	void OpenGLPaint();
	void OpenGLResize();
	void EventProc(XWindow& w, XEvent *event);
	void MoveSubWindow();

public:
	typedef OpenGLCtrl CLASSNAME;

	OpenGLCtrl();
	~OpenGLCtrl();

	void OpenGL();
	void CloseGL();

	void PostResizeGL();
	void PostPaintGL();

	// User methods
	virtual void InitGL();
	virtual void DoneGL();	
	virtual void ResizeGL( int w, int h );
	virtual void PaintGL();
	virtual void State(int reason);
};

#endif
